<template>
  <div id="tlm_tab_lecture_item_edit_wrapper" :key="refreshCount">
    <!-- 존나 신기하게 functional component는 v-show를 안먹는다 -->
    <div v-show="!isEditing">
      <!-- <div class="ps-align-right">
        TODO: 자동 모드 toggle
      </div> -->
      <lecture-item-list @delete="onClickDeleteLectureItem" @edit="onClickEditLectureItem"
        @simulate="onClickSimulateLectureItem" type="TEACHER" :list="lectureItemList" :sortableOptions="sortableOptions"
        :lectureType="lectureType" />

      <el-dialog :title="$t('ITEM.PREVIEW')" :visible.sync="dialogVisible" :before-close="handleClose" center
        :width="`${previewWidth}%`">
        <lecture-live-item v-if="dialogVisible" @isPreview="isPreview" :data="lectureItem" :onClick="onClick"
          :answerSubmitted="isSubmitted" type="TEACHER" />
        <br />
        <br />
        <span slot="footer" class="dialog-footer">
          <el-button @click="handleClose">{{ $t('DASHBOARD.QUIT') }}</el-button>
        </span>
      </el-dialog>

      <div v-if="connectMode">
        <el-tag v-for="(k, index) in connectList" :key="index">{{ k.name }}</el-tag>
        <el-button type="primary" @click="onClick('CONNECT_LC_ITEM')">
          {{ $t('ITEM.CONNECT') }}
        </el-button>
        <el-button @click="onClick('CANCEL_CONNECT_MODE')">
          {{ $t('ITEM.CANCEL') }}
        </el-button>
        <p>&#42; {{ $t('ITEM.CHIEF_ITEM_ENROLL') }}</p>
      </div>
      <p v-if="lectureType !== 0">&#42; {{ $t('HELP.ADD_ITEM5') }}</p>
      <br v-if="lectureType === 0" />
      <div class="box-container" style="display: flex; justify-content: flex-end">
        <!--router-link :to="`/a/teacher/NNlecture/itemgroup?lectureId=${lectureId}`" v-if="lectureType !== 0">
          <el-button type="primary">아이템 시간 설정</el-button>
        </router-link-->
        <!--el-button type="primary" v-if="lectureType !== 0" style="margin-right: 50px;" @click="onClick('CHANGE_ALL')">일괄 활성화 시간 설정</el-button-->
        <div style="width: auto; margin-right: 5px;">
          <a :href="downloadLink2" download="questionForm">
            <el-button type="success">
              {{ $t('QUESTION.FORM_DWNLD') }}
            </el-button>
          </a>
        </div>

        <!--문항 엑셀 업로드 -->
        <div style="width: auto; margin-right: 5px;">
          <el-upload :show-file-list="false" action="" :on-change="handleChange" :on-remove="handleRemove"
            :on-exceed="handleExceed" accept="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"
            :auto-upload="false">
            <el-button type="success">
              {{ $t('ITEM.UPLOAD_QUES') }}
            </el-button>
          </el-upload>
        </div>

        <!--문항 엑셀 다운로드 :choi -->
        <div style="width: auto; margin-right: 5px;">
          <el-button @click="ItemExcelDownload()" type="success">
            {{ $t('ITEM.DOWNLOAD_QUES') }}
          </el-button>
        </div> 

        <div style="width: auto; margin-right: 5px;">
          <el-button id="btn_add_new_lc_item" @click="onClick('ADD_NEW_LC_ITEM')" type="primary">
            {{ $t('ITEM.ADD') }}
          </el-button>
        </div>

        <div style="width: auto; margin-right: 5px;">
          <router-link :to="`/a/teacher/NNlecture/itemsetting?lectureId=${lectureId}`">
            <el-button type="primary">{{ $t('ITEM.STR_LEC_ITEM_ORD') }}</el-button>
          </router-link>
        </div>

        <!--el-button id="btn_add_new_lc_item" @click="onClick('ADD_LC_ITEM_SEQUENCE')" type="primary">
          세션 아이템 순서 저장
        </el-button-->

        <div>
          <router-link :to="`/a/teacher/NNlecture/newitemfrombank?classId=${classId}&lectureId=${lectureId}`">
            <el-button type="primary" :class="$attachReactablePostfix('right-align-btn')">
              <div class="right-align-btn-layer">{{ $t('ITEM.FROM_BANK') }}</div>
            </el-button>
          </router-link>
        </div>
        <el-popover style="margin-left: 10px; margin-top: 1px;" placement="bottom-start" width="650" trigger="hover">
          <el-table :data="notice">
            <el-table-column width="200" property="title" :label="$t('HELP.MODE')"></el-table-column>
            <el-table-column width="450" property="content" :label="$t('HELP.CONTENT')"></el-table-column>
          </el-table>
          <i class="el-icon-question fa-lg" slot="reference" style="font-size: 22px;"></i>
        </el-popover>
      </div>
    </div>


    <div v-if="ifShowCList">
      <el-table :data="connectedList">
        <el-table-column :label="$t('ITEM.CHIEF_ITEM')" width="300px">
          <template slot-scope="scope">
            <!--<el-tag v-for="(k, index) in scope.row" :key="index">{{ k.name }}</el-tag>-->
            {{ scope.row.leader }}
          </template>
        </el-table-column>
        <el-table-column :label="$t('ITEM.CONN_ITEM_LIST')">
          <template slot-scope="scope">
            <el-tag v-for="(k, index) in scope.row.list" :key="index">{{ k }}</el-tag>
          </template>
        </el-table-column>
        <el-table-column width="200px">
          <template slot-scope="scope">
            <el-button @click="onClick('DELETE_CONNECTION', scope.row)">{{ $t('ITEM.CONN_DEL') }}</el-button>
          </template>
        </el-table-column>
      </el-table>
      <div class="ps-align-right">
        <el-button @click="onClick('CLOSE_CONNECTION_MODE')">
          {{ $t('DASHBOARD.QUIT') }}
        </el-button>
      </div>
    </div>
    <div v-if="isEditing">
      <!--  <el-button @click="onClick('CANCEL_EDIT')" icon="el-icon-back">{{ $t('DASHBOARD.QUIT') }}!!</el-button> -->
      <lecture-item-editor :numOfLectureItem="numOfLectureItem" />
    </div>
  </div>
</template>

<script>
  import Sortable from 'sortablejs';
  import {
    mapState,
    mapGetters,
    mapMutations,
    mapActions
  } from 'vuex';
  import LectureItemList from '../partials/LectureItemList';
  import utils from '../../utils';
  import lectureItemService from '../../services/lectureItemService';
  import LectureItemEditor from '../partials/LectureItemEditor';
  import LectureLiveItem from '../partials/LectureLiveItem';
  import studentService from '../../services/studentService';
  import lectureService from '../../services/lectureService';
  // import { deflateRaw } from 'zlib';
  // import { POINT_CONVERSION_COMPRESSED } from 'constants';
  import {
    baseUrl
  } from '../../services/config';
  import XLSX from 'xlsx';
  import QuestionHandler from '../../handlers/lcItem/question';
  import {
    isNumber,
    isString
  } from 'util';
  import {
    EventBus
  } from '../../event-bus';
  import questionService from '../../services/questionService';

  // * 드래그 앤 드롭으로 테이블 행 순서 변경
  // * https://buefy.github.io/#/extensions/sortablejs
  // * TODO: 세션 순서에 대한 변수 생성(at backend) 후, start_time을 순서 변수로 변경
  const createSortable = (el, options, vnode) => { //eslint-disable-line

    let sequence = []; //eslint-disable-line
    return Sortable.create(el, {
      ...options,
      onStart() {
        // when the sort starts, store the initial order of the array
        sequence = this.toArray(); //eslint-disable-line
      },
      onEnd(evt) {
        // when the sort ends, set the order to the initial state
        this.sort(sequence); //eslint-disable-line
        // change the order using splice
        const data = vnode.context.lectureItemList;
        data.splice(evt.newIndex, 0, ...data.splice(evt.oldIndex, 1));
      },
    });
  };

  /**
   * We add a new instance of Sortable when the element
   * is bound or updated, and destroy it when it's unbound.
   */
  const sortable = {
    name: 'sortable',
    bind(el, binding, vnode) {
      const table = el.querySelector('.el-table__body-wrapper');
      table._sortable = createSortable(table.querySelector('tbody'), binding.value, vnode); //eslint-disable-line
    },
    update(el, binding, vnode) {
      const table = el.querySelector('.el-table__body-wrapper');
      table._sortable.destroy(); //eslint-disable-line
      table._sortable = createSortable(table.querySelector('tbody'), binding.value, vnode); //eslint-disable-line
    },
    unbind(el) {
      const table = el.querySelector('.el-table__body-wrapper');
      table._sortable.destroy(); //eslint-disable-line
    },
  };

  export default {
    name: 'TlmLectureItemEditTab',
    directives: {
      sortable
    },
    components: {
      LectureItemList,
      LectureItemEditor,
      LectureLiveItem,
    },
    data() {
      const vm = this;
      const initialInputHead = {
        lcItemOrder: 1,
        lcItemName: null,
        lcItemType: null,
        lcItemSequence: vm.numOfLectureItem + 1,
        lcItemResult: null,
        lcItemOffset: null,
        lcItemLimitLength: null,
      };
      const lectureItem = [];
      return {
        sortableOptions: {
          onUpdate: async (event) => {
            const vm = this;
            const showItem = vm.lectureItemList.filter(item => utils.convertLcItemTypeToNumber(item.type) !== 7);
            const oldItemIndex = vm.lectureItemList.findIndex(item => item.lecture_item_id === showItem[event
              .oldIndex].lecture_item_id);
            const newItemIndex = vm.lectureItemList.findIndex(item => item.lecture_item_id === showItem[event
              .newIndex].lecture_item_id);
            let newLectureItemList = [];
            vm.lectureItemList.forEach((item, index) => {
              if (index < oldItemIndex && index < newItemIndex) {
                newLectureItemList[index] = item;
                newLectureItemList[index].sequence = index;
              } else {
                if (index === oldItemIndex) {
                  newLectureItemList[newItemIndex] = item;
                  newLectureItemList[newItemIndex].sequence = newItemIndex;
                } else if (oldItemIndex < newItemIndex) {
                  newLectureItemList[index - 1] = item;
                  newLectureItemList[index - 1].sequence = index - 1;
                } else {
                  newLectureItemList[index + 1] = item;
                  newLectureItemList[index + 1].sequence = index + 1;
                }
              }
            });
            vm.$store.state.lc.lecture.lecture_items = newLectureItemList;
            vm.lectureItemList.forEach(async (item) => {
              await lectureItemService.putLectureItem({
                lectureItemId: item.lecture_item_id,
                sequence: item.sequence,
              });
            });
          }
        },
        refreshCount: 0,
        dialogVisible: false,
        lectureItem: undefined,
        currentLectureItemId: -1,
        isSubmitted: false,
        lectureType: 0,
        // 아이템 연결하는 화면인지
        connectMode: false,
        // 연결할 아이템 리스트
        connectList: [],
        // 리스트의 마지막 값
        lastConnect: -1,
        // 연결된 아이템 리스트
        connectedList: [],
        // 아이템 리스트 현황 보여주는지
        ifShowCList: false,
        notice: [{
          title: this.$t('QUESTION.FORM_DWNLD'),
          content: this.$t('HELP.QUESTIONS'),
        }, {
          title: this.$t('ITEM.UPLOAD_QUES'),
          content: this.$t('HELP.ADD_QUES'),
        }, {
          title: this.$t('ITEM.ADD'),
          content: this.$t('HELP.ADD_ITEM3'),
        }, {
          title: this.$t('ITEM.STR_LEC_ITEM_ORD'),
          content: this.$t('HELP.ADD_ITEM2'),
        }, {
          title: this.$t('ITEM.FROM_BANK'),
          content: this.$t('HELP.ADD_ITEM4'),
        }, ],
        downloadLink2: `${baseUrl}/downloads/questionForm`,
        fileTemp: null,
        sequenceOffset: 0,
        prev_sequenceOffset: 0,
      };
    },

    computed: {
      ...mapState('lc', [
        'lecture',
      ]),
      ...mapGetters('lcItem', [
        'isEditing',
      ]),
      previewWidth() {
        const vm = this;
        return vm.lectureItem !== undefined && vm.lectureItem.type === 0 && vm.lectureItem.questions.length > 0 && vm
          .lectureItem.questions[0].type === 7 ? 60 : 30;
      },
      lectureItemList() {
        const lecture = this.$store.state.lc.lecture;
        const vm = this;
        if (lecture && Array.isArray(lecture.lecture_items)) {
          /*
          const lectureItemList = lecture.lecture_items.map((x) => {
            x.type = utils.convertLcItemTypeKor(x.type); // eslint-disable-line no-param-reassign
            x.offset = utils.convertSecondTohhmmss(x.offset); // eslint-disable-line no-param-reassign
            return x;
          });
          // * sequence 순서대로 세션 아이템 정렬
          lectureItemList.sort((a, b) => {
            const aItemSequence = Number(a.sequence);
            const bItemSequence = Number(b.sequence);
            return aItemSequence - bItemSequence;
          });
          return lectureItemList;
          */
          // lcStore 의 lecture item의 타입이 lectureItemList() 호출 시마다 convert 됨 => 초기 숫자 => 문자 타입, 다음번 문자 => undefined 됨
          // 아이템 없을때 addEventListner가 작동을 하지 않아서 새로 만들때 호출되는 여기다가 추가함
          if (lecture.lecture_items.length) {
            vm.addTableEventListener();
          }
          return lecture.lecture_items.map((item) => {
            const item2 = JSON.parse(JSON.stringify(item));
            item2.sequence = Number(item2.sequence);
            // 숫자 일때만 변경
            if (!isNaN(item2.type)) {
              item2.type = utils.convertLcItemTypeKor(item2.type); // eslint-disable-line no-param-reassign
            }
            item2.offset = utils.convertSecondTohhmmss(item2.offset); // eslint-disable-line no-param-reassign
            return item2;
          }).sort((a, b) => {
            return Number(a.sequence) - Number(b.sequence);
          });
        }
        return [];
      },
      classId() { // 190709 추가
        const vm = this;
        return Number.parseInt(vm.$route.query.classId, 10);
      },
      lectureId() {
        const vm = this;
        return Number.parseInt(vm.$route.params.lectureId, 10);
      },
      numOfLectureItem() {
        const vm = this;
        return vm.lectureItemList.length;
      },
    },

    methods: {
      ...mapActions('lc', [
        'getLecture',
      ]),
      ...mapMutations('lcItem', [
        'updateCurrentEditingLectureItemId',
        'updateLectureItem',
      ]),
      ...mapActions('lcItem', [
        'postLcItem',
      ]),
      async onClick(type, data) {
        const vm = this;
        const leck = await lectureService.getLectureKeywords({
          lectureId: vm.$route.params.lectureId,
        });
        const kl = leck.data.length;
        switch (type) {
          // 아이템 연결
          case 'CONNECT_LC_ITEM': {
            const vm = this;
            // 연결할 아이템이 없거나 한개일 경우
            if (vm.connectList.length < 2) {
              vm.$notify({
                title: vm.$t('NOTIFY.TITLE'),
                message: vm.$t('NOTIFY.SLCT_ITEMS_CONN'),
                type: 'warning',
              });
              break;
            }
            const tmp = [];
            vm.connectList.forEach((x) => {
              tmp.push(x.id);
            });
            lectureItemService.makeConnection({
              lectureId: vm.$route.params.lectureId,
              iList: tmp,
            }).then(() => {
              // 성공했을 경우 아이템 연결 리스트 삭제
              vm.connectList = [];
              // 아이템 연결 목록 화면이 보여지고 있을 경우, 리스트 갱신
              if (vm.ifShowCList === true) {
                vm.connectLcItemList();
              }
              // 성공했을 경우 알림 메시지
              vm.$notify({
                title: vm.$t('NOTIFY.TITLE'),
                message: vm.$t('NOTIFY.CONN_SUCCESS'),
                type: 'success',
              });
            }).catch(() => {
              // 오류 발생
              vm.$notify({
                title: vm.$t('NOTIFY.TITLE'),
                message: vm.$t('NOTIFY.ITEM_EXIST_LST'),
                type: 'warning',
              });
            });
            break;
          }
          // 아이템 연결 삭제
          case 'DELETE_CONNECTION': {
            const vm = this;
            const delId = data.leaderId;
            // 서버에서 삭제
            lectureItemService.deleteConnection({
              lectureItemId: delId,
            });
            // 프론트에서 삭제
            let delFId = -1;
            vm.connectedList.forEach((x, index) => {
              if (x.leaderId === delId) {
                delFId = index;
              }
            });
            vm.connectedList.splice(delFId, 1);
            break;
          }
          // 아이템 연결 취소
          case 'CANCEL_CONNECT_MODE': {
            this.connectList = [];
            this.connectMode = false;
            break;
          }
          // 아이템 연결 화면 닫기
          case 'CLOSE_CONNECTION_MODE': {
            this.ifShowCList = false;
            break;
          }
          case 'ADD_LC_ITEM_SEQUENCE': {
            this.lectureItemList.forEach((item, index) => {
              lectureItemService.putLectureItem({
                lectureItemId: item.lecture_item_id,
                sequence: index + 1,
              });
            });
            break;
          }
          case 'ADD_NEW_LC_ITEM': {
            if (kl === 0) {
              this.$notify({
                title: vm.$t('ITEM.NOKEYWORD'),
                message: vm.$t('ITEM.NOKEYMES'),
                type: 'error',
              });
            } else {
              this.ifShowCList = false;
              this.connectMode = false;
              this.connectList = [];
              this.updateCurrentEditingLectureItemId({
                currentEditingLectureItemId: -1,
              });
            }
            break;
          }
          case 'CANCEL_EDIT': {
            this.updateCurrentEditingLectureItemId({
              currentEditingLectureItemId: null,
            });
            break;
          }
          case 'SUBMIT': {
            this.isSubmitted = true;
            switch (this.lectureItem.type) {
              case 0: { // 문항
                studentService.submitQuestion({
                  questionId: data.questionId,
                  answers: data.answer,
                  interval: 0,
                  codeLanguage: data.language,
                });
                this.$notify({
                  title: vm.$t('NOTIFY.TITLE'),
                  message: vm.$t('NOTIFY.SUBMITTED'),
                  type: 'success',
                });
                this.lectureItem = undefined;
                this.refreshLectureItem(this.currentLectureItemId);
                break;
              }
              case 1: { // 설문
                studentService.submitSurvey({
                  surveyId: data.surveyId,
                  answer: data.answer,
                });
                this.lectureItem = undefined;
                this.refreshLectureItem(this.currentLectureItemId);
                break;
              }
              default: {
                throw new Error(`not defined type ${type}`);
              }
            }
            break;
          }
          case 'CHANGE_ALL': { // 모든 아이템 활성화 시간 일괄 변경
            break;
          }
          default: {
            throw new Error(`not defined type ${type}`);
          }
        }
      },
      tableEventListener(event) {
        const vm = this;
        vm.$store.state.lc.lecture.lecture_items = vm.$store.state.lc.lecture.lecture_items.sort((a, b) => {
          return a.sequence - b.sequence;
        });
        vm.refreshCount += 1;
        // refreshCount 증가로 인하여 다시 rendering 될 때 dragend 이벤트가 등록된 table element를 다시 이벤트를 등록해줘야됨(table이 기존 element가 아닌 다른 element로 대체 되기 때문에)
        vm.$nextTick(() => {
          vm.addTableEventListener();
        });
      },
      addTableEventListener() {
        const vm = this;
        const table = document.querySelector('#lecture_item_list_wrapper .el-table__body');
        if (!table) {
          return;
        }
        table.addEventListener('dragend', vm.tableEventListener);
      },
      // 아이템 연결 리스트에 선택한 아이템 추가
      async onClickConnectLectureItem(arg) {
        const vm = this;
        const lectureItemId = arg.lecture_item_id;
        // 만약 리스트가 비어있지 않고
        if (vm.connectList.length !== 0) {
          // 리스트의 마지막 아이템의 다음 줄에 위치한 아이템이 아닐 경우
          const thisSeq = arg.sequence;
          if (vm.lastConnect !== thisSeq - 1) {
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.NOT_CON_ITEM_MES'),
              type: 'warning',
            });
            return;
          }
        }
        // 마지막 번호 갱신
        vm.lastConnect = arg.sequence;
        // 이미 리스트에 있다면 중복 방지
        let ifDupli = false;
        vm.connectList.forEach((x) => {
          if (x.id === lectureItemId) {
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.ALRD_ADD_LIST'),
              type: 'warning',
            });
            ifDupli = true;
          }
        });
        if (ifDupli === true) {
          return;
        }
        // 없다면 리스트에 넣어줌
        vm.connectMode = true;
        const tmp = {};
        tmp.id = lectureItemId;
        const res = await lectureItemService.getLectureItem({
          lectureItemId
        });
        tmp.name = res.data.name;
        vm.connectList.push(tmp);
      },
      // 아이템 연결 리스트에서 한 항목 삭제
      deleteConnectItem(index) {
        this.connectList.splice(index, 1);
      },
      // 아이템 연결 리스트 보여주기
      async connectLcItemList() {
        const vm = this;
        vm.ifShowCList = true;
        vm.connectedList = [];
        const res = await lectureItemService.showConnection({
          lectureId: vm.$route.params.lectureId,
        });
        let i = 0;
        let j = 0;
        for (i = 0; i < res.data.length; i += 1) {
          const nowConnect = {};
          const lectureItemId = res.data[i].item_id;
          nowConnect.leaderId = lectureItemId;
          const po = await lectureItemService.getLectureItem({
            lectureItemId
          }); // eslint-disable-line
          nowConnect.leader = po.data.name;

          const namugi = res.data[i].linked_list;
          // 대표문항에 연결된 아이템들이 여러 개
          if (namugi.includes('<$!<>') === true) {
            const namugiSplit = namugi.split('<$!<>');
            const tmp = [];
            for (j = 0; j < namugiSplit.length; j += 1) {
              const lectureItemIds = namugiSplit[j];
              const pw = await lectureItemService.getLectureItem({ // eslint-disable-line
                lectureItemId: lectureItemIds,
              });
              tmp.push(pw.data.name);
            }
            nowConnect.list = tmp;
          } else { // 대표문항에 연결된 아이템이 하나
            const pws = await lectureItemService.getLectureItem({ // eslint-disable-line
              lectureItemId: namugi,
            });
            nowConnect.list = [];
            nowConnect.list.push(pws.data.name);
          }
          vm.connectedList.push(nowConnect);
        }
      },
      onClickEditLectureItem(lectureItemId) {
        this.updateCurrentEditingLectureItemId({
          currentEditingLectureItemId: lectureItemId,
        });
      },
      /**
       * 얘는 onClick에서 넘겨주면 index를 못받아와서 안됨
       */
      async onClickSimulateLectureItem(lectureItemId) {
        const vm = this;
        const res = await lectureItemService.getLectureItem({
          lectureItemId
        });
        await lectureItemService.putLectureItem({
          lectureItemId,
          opened: 1,
        });
        vm.currentLectureItemId = lectureItemId;
        vm.dialogVisible = true;
        vm.lectureItem = res.data;
        if(vm.lectureItem.questions[0]) {
          vm.lectureItem.questions[0].problem_testcases.sort((a, b) => {
            return a.num - b.num;
          });
        }        
      },
      isPreview() { // 미리보기 구별용 함수
        return;
      },
      async onClickDeleteLectureItem(index) {
        const vm = this;
        const targetLectureItem = vm.lectureItemList.filter(item => utils.convertLcItemTypeToNumber(item.type) !== 7)[
          index];

        // 그룹이 아닌 경우 -> 그냥 삭제하면 됨
        // 단독 그룹이자 단독 리스트 -> 삭제하면서 리스트, 그룹 삭제
        // 복수 그룹이자 단독 리스트 -> 삭제 방지
        const res = await lectureItemService.showConnection({
          lectureId: this.$route.params.lectureId,
        });
        const res2 = await lectureItemService.showSmallGroup({
          lectureId: this.$route.params.lectureId,
        });

        let smallGroupList = [];
        res2.data.group.forEach((x) => {
          if (x.linked_small_group.includes('<$!<>') === true) {
            const spl = x.linked_small_group.split('<$!<>');
            //let tmpL = [];
            spl.forEach((y) => {
              //tmpL.push(y * 1);
              smallGroupList.push(y * 1);
            });
            //smallGroupList.push(tmpL);
          } else {
            smallGroupList.push(x.linked_small_group * 1);
          }
        });

        let listN;
        let mainItemId;
        let listNm;
        res.data.forEach((x) => {
          if (x.linked_list.includes('<$!<>') === true) { // shuffle 아닌 그룹
            const spl = x.linked_list.split('<$!<>');
            spl.forEach((y) => {
              if (parseInt(y, 10) === targetLectureItem.lecture_item_id) {
                listN = x.lecture_item_list_id;
                listNm = spl.length;
                mainItemId = x.item_id;
              }
            });
          } else if (parseInt(x.linked_list, 10) === targetLectureItem.lecture_item_id) {
            let flag = true;
            smallGroupList.forEach((y) => {
              // if (y.length != undefined) {
              //   y.forEach((z) => {
              //     if (x.lecture_item_list_id === z) {
              //       listN = x.lecture_item_list_id;
              //       listNm = 2;
              //       mainItemId = x.item_id;
              //       flag = false;
              //     }
              //   });
              // } else 
              if (x.lecture_item_list_id ===
                y) { // small 그룹 안에 속함, 즉 복수 그룹(그룹 안에 아이템이 여러 개) => 지울 수 없다 (대충 nm 2로 설정)
                listN = x.lecture_item_list_id;
                listNm = 2;
                mainItemId = x.item_id;
                flag = false;
              }
            });
            if (flag === true) {
              listN = x.lecture_item_list_id;
              listNm = 1;
              mainItemId = x.item_id;
            }
          }
          // } else if (parseInt(x.linked_list, 10) === targetLectureItem.lecture_item_id) {
          //   listN = x.lecture_item_list_id;
          //   listNm = 1;
          //   mainItemId = x.item_id;
          // }
        });
        const rest = await lectureItemService.showGroup({
          lectureId: this.$route.params.lectureId,
        });
        let dupGrp = false;
        let ifGrp = '';
        smallGroupList.forEach((z) => {
          if (z === listN) dupGrp = true;
        })
        rest.data.list.forEach((z) => {
          // 어떤 그룹에 속하는데 다른 아이템과 함께 그룹을 이룰 경우 삭제 불가
          if (z.list_ids.includes(`${listN}`) === true) {
            ifGrp = z.group_id;
            if (listNm > 1 || z.list_ids.length > 1) {
              dupGrp = true;
            }
          }
        });
        // 원래 다른 아이템과 그룹져있으면 삭제 불가했지만 가능하도록 주석처리
        if (dupGrp === true) {
          vm.$confirm(vm.$t('NOTIFY.WANT_DEL_ITEM'), `${targetLectureItem.name || ''}`, {
              confirmButtonText: vm.$t('NOTE.CONFIRM'),
              cancelButtonText: vm.$t('NOTIFY.CANCEL'),
              type: 'warning',
            }).then(async () => {
              try {
                // 아이템 삭제
                await lectureItemService.deleteLectureItem({
                  lectureItemId: targetLectureItem.lecture_item_id,
                });
                // 연결 리스트 수정
                const res = await lectureItemService.showConnection({
                  lectureId: this.$route.params.lectureId,
                });
                let item_list = res.data;
                let item_list_id = -1;
                let list = [];
                for (let i = 0; i < item_list.length; i++) {
                  let linked_list = item_list[i].linked_list.split('<$!<>');
                  for (let j = 0; j < linked_list.length; j++) {
                    if (linked_list[j] === String(targetLectureItem.lecture_item_id)) {
                      item_list_id = item_list[i].lecture_item_list_id;
                      linked_list.splice(j, 1);
                      linked_list.forEach((link) => {
                        list.push(link);
                      });
                    }
                    if (item_list_id !== -1) {
                      break;
                    }
                  }
                  if (item_list_id !== -1) {
                    break;
                  }
                }
                await lectureItemService.updateGroupList({
                  itemListId: item_list_id,
                  linkedList: list.join('<$!<>'),
                });
                // 프론트에서 아이템 지워주기
                const oriI = vm.lectureItemList.indexOf(targetLectureItem);
                vm.lectureItemList.splice(oriI, 1);
                // 삭제한 뒤에 아이템 다시 서버에 업로드
                await vm.lectureItemList.forEach((item, i) => {
                  if (item.sequence - 1 > index) {
                    lectureItemService.putLectureItem({
                      lectureItemId: vm.lectureItemList[i].lecture_item_id,
                      sequence: item.sequence - 1,
                    });
                  }
                });
                // TODO: delete lectureItem from lecture.lecture_items
                await vm.getLecture({
                  lectureId: vm.lectureId
                });
              } catch (error) {
                vm.$notify({
                  title: vm.$t('NOTIFY.LEC_ITEM_DEL_FAIL'),
                  message: error.toString(),
                  type: 'error',
                  duration: 3000,
                });
              }
            })
            .catch(() => {
              vm.$notify({
                title: vm.$t('NOTIFY.CANCELLED'),
                message: vm.$t('NOTIFY.LEC_ITEM_DEL_CNCL'),
                type: 'info',
                duration: 3000,
              });
            });
          return;
        }

        vm.$confirm(vm.$t('NOTIFY.WANT_DEL_ITEM'), `${targetLectureItem.name || ''}`, {
            confirmButtonText: vm.$t('NOTE.CONFIRM'),
            cancelButtonText: vm.$t('NOTIFY.CANCEL'),
            type: 'warning',
          })
          .then(async () => {
            try {
              // 그룹 삭제 (있다면)
              if (ifGrp !== '') {
                await lectureItemService.deleteGroup({
                  groupId: ifGrp,
                });
              }
              // 연결 리스트 삭제
              await lectureItemService.deleteConnection({
                lectureItemId: targetLectureItem.lecture_item_id,
              });
              // 아이템 삭제
              await lectureItemService.deleteLectureItem({
                lectureItemId: targetLectureItem.lecture_item_id,
              });
              // 프론트에서 아이템 지워주기
              const oriI = vm.lectureItemList.indexOf(targetLectureItem);
              vm.lectureItemList.splice(oriI, 1);
              // 삭제한 뒤에 아이템 다시 서버에 업로드
              await vm.lectureItemList.forEach((item, i) => {
                if (item.sequence - 1 > index) {
                  lectureItemService.putLectureItem({
                    lectureItemId: vm.lectureItemList[i].lecture_item_id,
                    sequence: item.sequence - 1,
                  });
                }
              });
              // TODO: delete lectureItem from lecture.lecture_items
              await vm.getLecture({
                lectureId: vm.lectureId
              });
            } catch (error) {
              vm.$notify({
                title: vm.$t('NOTIFY.LEC_ITEM_DEL_FAIL'),
                message: error.toString(),
                type: 'error',
                duration: 3000,
              });
            }
          })
          .catch(() => {
            vm.$notify({
              title: vm.$t('NOTIFY.CANCELLED'),
              message: vm.$t('NOTIFY.LEC_ITEM_DEL_CNCL'),
              type: 'info',
              duration: 3000,
            });
          });
      },
      refreshLectureItem(lectureItemId) {
        const vm = this;
        // opened 상태인 아이템이 있다면 보이기 : 빠른 속도로 아이템 보임/숨김 조작하는 경우 버그 해결하기위해 1초 지연
        setTimeout(async () => {
          const res3 = await lectureItemService.getLectureItem({
            lectureItemId
          });
          if (res3.data !== null) {
            vm.lectureItem = res3.data;
          } else {
            vm.lectureItem = undefined;
          }
        }, 1000);
      },
      handleClose() {
        const vm = this;
        vm.dialogVisible = false;
        if (vm.isSubmitted) {
          if (vm.lectureItem.type === 0) {
            studentService.deleteQuestionAnswerLog({
              questionId: vm.lectureItem.questions[0].question_id,
            });
          } else if (vm.lectureItem.type === 1) {
            studentService.deleteSurveyAnswerLog({
              surveyId: vm.lectureItem.surveys[0].survey_id,
            });
          }
        }
        lectureItemService.putLectureItem({
          lectureItemId: vm.lectureItem.lecture_item_id,
          opened: 0,
        });
        vm.isSubmitted = false;
      },
      handleChange(file, fileList) {
        const vm = this;
        vm.fileTemp = file.raw;
        if (vm.fileTemp) {
          if ((vm.fileTemp.type == 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet')) {
            vm.importfxx(vm.fileTemp);
          } else {
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('KEYWORD.FORMAT_ERROR'),
              type: 'warning',
            });
          }
        }
      },
      //Processing method when exceeding the maximum number of uploaded files
      handleExceed() {
        const vm = this;
        vm.$notify({
          title: vm.$t('NOTIFY.TITLE'),
          message: vm.$t('KEYWORD.MAXIMUM_ERROR'),
          type: 'warning',
        })
        return;
      },
      //How to remove files
      handleRemove(file, fileList) {
        const vm = this;
        vm.fileTemp = null;
      },
      importfxx(obj) {
        let vm = this;
        let inputDOM = vm.$refs.inputer;
        // Retrieving file data through DOM
        vm.file = event.currentTarget.files[0];
        var rABS = false; //Read the file as a binary string
        var f = vm.file;
        var reader = new FileReader();
        //if (!FileReader.prototype.readAsBinaryString) {
        FileReader.prototype.readAsBinaryString = function (f) {
          var binary = "";
          var rABS = false; //Read the file as a binary string
          var pt = vm;
          var wb; //Read completed data
          var outdata = [];
          var tmpdata;
          var reader = new FileReader();
          reader.onload = async function (e) {
            var bytes = new Uint8Array(reader.result);
            var length = bytes.byteLength;
            for (var i = 0; i < length; i++) {
              binary += String.fromCharCode(bytes[i]);
            }
            //If not introduced in main.js, you need to introduce it here to parse excel
            // var XLSX = require("xlsx");
            if (rABS) {
              wb = XLSX.read(btoa(fixdata(binary)), {
                //Manual conversion
                type: "base64"
              });
            } else {
              wb = XLSX.read(binary, {
                type: "binary"
              });
            }
            const tmp_arr = await lectureService.getLectureKeywords({
              lectureId: vm.lectureId,
            });
            let session_keywords = [];
            tmp_arr.data.forEach((key) => {
              session_keywords.push(key.keyword);
            });
            // 단답, 객관, 서술 섞여 있음
            tmpdata = XLSX.utils.sheet_to_json(wb.Sheets[wb.SheetNames[0]]);
            outdata.push(tmpdata);
            tmpdata = XLSX.utils.sheet_to_json(wb.Sheets[wb.SheetNames[1]]);
            outdata.push(tmpdata);
            tmpdata = XLSX.utils.sheet_to_json(wb.Sheets[wb.SheetNames[2]]);
            outdata.push(tmpdata);
            // 모든 행의 개수 세기
            let total_rows = outdata[0].length + outdata[1].length + outdata[2].length;
            vm.sequenceOffset = vm.numOfLectureItem;
            vm.prev_sequenceOffset = vm.numOfLectureItem;
            //outdata is read data (without header rows or headers, the header will be the subscript of the object)
            //Data can be processed here.
            let arr = [];
            for (let i = 0; i < outdata.length; i++) {
              // 단답식
              if (i === 0) {
                for (let j = 0; j < outdata[0].length; j++) {
                  let item = outdata[0][j];
                  let obj = {};
                  obj.item_type = 0;
                  obj.type = item['타입'];
                  obj.name = item['아이템 이름'];
                  obj.open = item['중복 제출 및 답안 공개 여부'];
                  obj.question = item['문제'];
                  obj.answer = item['답'];
                  obj.difficulty = item['난이도'];
                  obj.limit = item['글자수 제한'];
                  obj.limit_num = item['제한 수'];
                  obj.keywords = item['키워드'];
                  obj.allots = item['키워드 배점'];
                  arr.push(obj);
                }
              }
              // 객관식
              if (i === 1) {
                for (let j = 0; j < outdata[1].length; j++) {
                  let item = outdata[1][j];
                  let obj = {};
                  obj.item_type = 1;
                  obj.type = item['타입'];
                  obj.name = item['아이템 이름'];
                  obj.open = item['중복 제출 및 답안 공개 여부'];
                  obj.question = item['문제'];
                  obj.sheet1 = item['보기1'];
                  obj.sheet2 = item['보기2'];
                  obj.sheet3 = item['보기3'];
                  obj.sheet4 = item['보기4'];
                  obj.sheet5 = item['보기5'];
                  obj.correct_answer = item['정답'];
                  obj.difficulty = item['난이도'];
                  obj.keywords = item['키워드'];
                  obj.allots = item['키워드 배점'];
                  arr.push(obj);
                }
              }
              // 서술식
              if (i === 2) {
                for (let j = 0; j < outdata[2].length; j++) {
                  let item = outdata[2][j];
                  let obj = {};
                  obj.item_type = 2;
                  obj.type = item['타입'];
                  obj.name = item['아이템 이름'];
                  obj.open = item['중복 제출 및 답안 공개 여부'];
                  obj.question = item['문제'];
                  obj.answer = item['모범 답안'];
                  obj.difficulty = item['난이도'];
                  obj.limit = item['글자수 제한'];
                  obj.limit_num = item['제한 수'];
                  obj.keywords = item['키워드'];
                  obj.allots = item['키워드 배점'];
                  arr.push(obj);
                }
              }
            }
            
            await vm.questionSubmit(arr, session_keywords);

          };
          reader.readAsArrayBuffer(f);
        };
        if (rABS) {
          reader.readAsArrayBuffer(f);
        } else {
          reader.readAsBinaryString(f);
        }
      },
      async questionSubmit(questions, session_keywords) {
        const vm = this;

        // ***** 유효성 검사 *****

        for (let i = 0; i < questions.length; i++) {
          const ques = questions[i];

          // 문항 유형이 단답, 객관, 서술이 아니라면 제거
          if (ques.item_type === 3) {
            continue;
          }

          // 자료,문항,실습은 키워드가 없다면 알람을 띄우고 막음
          if (ques.keywords === undefined) {
            continue;
          }

          // 해당 세션의 키워드가 아니라면 제거
          const keywords = ques.keywords.split(',');
          let flag = false;
          keywords.forEach((key) => {
            if (!session_keywords.includes(key)) {
              flag = true;
              return;
            }
          });
          if (flag)
            continue;

          // 문항 - 단답에 답이 없으면 제출 불가
          if (ques.item_type === 0 && ques.answer === undefined) {
            continue;
          }

          // 문항 - 객관 보기가 하나라도 없으면 제출 불가
          if (ques.item_type === 1 && (ques.sheet1 === undefined || ques.sheet2 === undefined ||
              ques.sheet3 === undefined || ques.sheet4 === undefined || ques.sheet5 === undefined)) {
            continue;
          }

          // 문항 객관식 - 정답을 반드시 선택해야 함
          if (ques.item_type === 1 && ques.correct_answer === undefined) {
            continue;
          }

          // 문항 - 중복 제출 여부 선택해야 함
          if (ques.open === undefined) {
            continue;
          }

          // 문항 - 키워드의 배점 제한(1~100점)
          const allotss = ques.allots.toString().split(',');
          flag = false;
          for (let m = 0; m < allotss.length; m++) {
            if (!(Number(allotss[m]) >= 1 && Number(allotss[m]) <= 100)) {
              flag = true;
              break;
            }
          }
          if (flag)
            continue;

          // 문항(단답, 서술), 설문, 토론 - 글자 수 제한(1~999숫자만)
          // 입력값이 숫자가 아닐 경우 또는 1과 999 사이의 숫자가 아닌 경우
          if ((ques.limit === '제한 있음') && !(ques.limit_num >= 1 && ques.limit_num <= 999)) {
            continue;
          }

          // ***** 유효성 검사 끝 *****

          // 단답형 문항 데이터 만들기
          let inputHead = {};
          // 글자 수 제한
          if (ques.item_type === 0 || ques.item_type === 2) {
            if (ques.limit === '제한 있음')
              inputHead.lcItemLimitLength = ques.limit_num;
            else
              inputHead.lcItemLimitLength = null;
          } else if (ques.item_type === 1) {
            inputHead.lcItemLimitLength = null;
          }
          // 아이템 이름
          inputHead.lcItemName = ques.name;
          // 뭔지 모르겠당
          inputHead.lcItemOffset = null;
          // 타입
          if (ques.type === '예습')
            inputHead.lcItemOrder = 0;
          else if (ques.type === '본강')
            inputHead.lcItemOrder = 1;
          else if (ques.type === '복습')
            inputHead.lcItemOrder = 2;
          // 중복 제출 여부
          if (ques.open === '답안은 공개되지 않습니다.')
            inputHead.lcItemResult = 0;
          else if (ques.open === '답안은 강습자님이 아이템을 내리실때 공개됩니다.')
            inputHead.lcItemResult = 3;
          // 추가 전 전체 아이템 갯수 + 1
          vm.sequenceOffset += 1;
          inputHead.lcItemSequence = vm.sequenceOffset;
          // 문항을 영어로 question
          inputHead.lcItemType = 'question';

          let inputBody = {};
          // 단답이냐 객관이냐 서술이냐
          if (ques.item_type === 0)
            inputBody.questionType = 'SHORT_ANSWER';
          if (ques.item_type === 1)
            inputBody.questionType = 'MULTIPLE_CHOICE';
          if (ques.item_type === 2)
            inputBody.questionType = 'DESCRIPTION';

          let inputTail = {};
          // 답
          if (ques.item_type === 0 || ques.item_type === 2) { // 단답형 서술형
            inputTail.answer = ques.answer.split('@@');
          } else if (ques.item_type === 1) { // 객관형
            if (isNumber(ques.correct_answer))
              inputTail.answer = [ques.correct_answer.toString()];
            else if (isString(ques.correct_answer))
              inputTail.answer = ques.correct_answer.split(',');
          }
          // 서술형 답 파일?
          if (ques.item_type === 2) {
            inputTail.answerFile = [];
          }
          // ??
          inputTail.answerMediaType = 'none';
          // 키워드 및 배점
          let assignedKeywords = [];
          let keywordList = ques.keywords.split(',');
          let allotList = [];
          if (isNumber(ques.allots)) {
            allotList.push(ques.allots.toString());
          } else if (isString(ques.allots)) {
            allotList = ques.allots.split(',');
          }
          for (let j = 0; j < keywordList.length; j++) {
            let obj = {};
            obj.keyword = keywordList[j];
            obj.score = allotList[j];
            assignedKeywords.push(obj);
          }
          inputTail.assignedKeywordList = assignedKeywords;
          // 뭔지 모르는 3가지
          inputTail.audioBlob = [];
          inputTail.blobURL = [];
          inputTail.choice2 = [];
          // 난이도
          inputTail.difficulty = ques.difficulty;
          // ??
          inputTail.multiChoiceMedia = [];
          inputTail.multiChoiceMediaType = 'none';
          // 문제
          inputTail.question = ques.question;
          // 이미지url 인듯
          inputTail.questionBlobURL = undefined;
          // 문제 파일 인듯
          inputTail.questionFile = [];
          // 객관형 보기
          if (ques.item_type === 1) {
            inputTail.questionList = [];
            inputTail.questionList.push(ques.sheet1);
            inputTail.questionList.push(ques.sheet2);
            inputTail.questionList.push(ques.sheet3);
            inputTail.questionList.push(ques.sheet4);
            inputTail.questionList.push(ques.sheet5);
          }
          // 뭐... 기타 등등
          inputTail.questionMediaType = 'none';
          if (ques.item_type === 1) {
            inputTail.questionVideo = [];
          }
          inputTail.questionVoiceFile = undefined;
          inputTail.questionYoutubeURL = undefined;
          inputTail.recorder = null;
          inputTail.recordingBtnNum = -1;
          inputTail.testCaseList = [{
            input: "",
            output: ""
          }];
          try {
            // 아이템 만들기
            await vm.postLcItem({
              inputHead: inputHead,
              inputBody: inputBody,
              inputTail: inputTail,
            });
            // vm.$notify({
            //   title: vm.$t('NOTIFY.CRE_COMP'),
            //   message: vm.$t('NOTIFY.ITEM_CRE'),
            //   type: 'success',
            // });

            vm.reset();
            // await vm.getLecture({ lectureId: vm.lectureId }); // lecture item list 업데이트
          } catch (error) {
            // vm.$notify({
            //   title: vm.$t('NOTIFY.CRE_FAIL'),
            //   message: error.toString(),
            //   type: 'error',
            //   duration: 0,
            // });
          }
        }
        setTimeout(async () => {
          await vm.getLecture({
            lectureId: vm.lectureId
          });
        }, 1000);
      },
      async reset() {
        const vm = this;
        await vm.updateCurrentEditingLectureItemId({
          currentEditingLectureItemId: null,
        });
        await vm.updateLectureItem({
          lectureItem: null,
        });
        // const lcItemType = "question"; // 무조건 문항
        // vm.$refs[`${lcItemType}Editor`].reset();
        // vm.inputHead = Object.assign({}, vm.initialInputHead);
      },
     
      // async ItemExcelDownload2() //choi --> foreach로 바꾸면서 문제 발생
      // {
      //   const vm = this;
      //   var Short_Ans_list = []; //단답 리스트
      //   var Multi_Ans_list = []; //객관 리스트
      //   var Essay_list = []; //서술 리스트
      
        // vm.lectureItemList.forEach(async (i) => {
        // if(i.type === '문항') //문항에 대해서만 excel 다운로드
        // {
        //   if(i.questions[0].type === 1) //단답형인 경우
        //   {
        //     var tmp = { };
        //     switch(i.order)
        //     {
        //       case 0 : tmp['타입'] = '예습'; break;
        //       case 1 : tmp['타입'] = '본강'; break;
        //       case 2 : tmp['타입'] = '복습'; break;
        //     }
          
        //     tmp['아이템 이름'] =i.name; //아이템 이름
           
        //     switch(i.result)
        //     {
        //       case 0 : tmp['답안 공개 여부'] = '답안은 공개되지 않습니다..'; break;
        //       case 3 : tmp['답안 공개 여부'] = "답안은 강사님이 아이템을 내리실때 공개됩니다."; break;
            
        //     }
           
        //     tmp['문제'] = i.questions[0].question; //문제
        //     tmp['답'] = i.questions[0].answer; //답안
        //     tmp['난이도'] = i.questions[0].difficulty; //난이도
            
        //     if(i.limit_length != null)
        //     {
        //       tmp['글자수 제한'] = "제한 있음";
        //     }
        //     else tmp['글자수 제한'] = "제한없음"; //글자수 제한 여부
            
        //     if(i.limit_length != null)
        //     {
        //       tmp['제한 수'] = i.limit_length;
        //     }
        //     else tmp['제한 수'] = " "; //글자수 제한수
            
        //     const keywordList = await questionService.getQuestionKeywords({
        //         questionId: i.questions[0].question_id,
        //     });
            
            
        //     tmp['키워드']=keywordList.data[0].keyword;
            
        //     keywordList.data.forEach(async (i) =>{
            
        //       tmp['키워드'] += ','
        //       tmp['키워드'] += i.keyword;              
        //     });
        //      tmp['키워드 배점']=keywordList.data[0].score_portion;
            
        //      keywordList.data.forEach(async (i) =>{            
        //       tmp['키워드 배점'] += ','
        //       tmp['키워드 배점'] += i.score_portion;              
        //     });

        //     Short_Ans_list.push(tmp);                  
        //   }
        //   if(i.questions[0].type === 0) //객관형인 경우
        //   {
        //     let tmp = { };
        //     switch(i.order)
        //     {
        //       case 0 : tmp['타입'] = '예습'; break;
        //       case 1 : tmp['타입'] = '본강'; break;
        //       case 2 : tmp['타입'] = '복습'; break;
        //     }
            
        //     tmp['아이템 이름'] = i.name; //아이템 이름
         
        //     switch(i.result)
        //     {
        //       case 0 : tmp['답안 공개 여부'] = '답안은 공개되지 않습니다..'; break;
        //       case 3 : tmp['답안 공개 여부'] = "답안은 강사님이 아이템을 내리실때 공개됩니다."; break;
            
        //     }
        //     tmp['문제'] = i.questions[0].question; //문제
        //     tmp['보기1'] = i.questions[0].choice.split('<$!<>')[0];
        //     tmp['보기2'] = i.questions[0].choice.split('<$!<>')[1];
        //     tmp['보기3'] = i.questions[0].choice.split('<$!<>')[2];
        //     tmp['보기4'] = i.questions[0].choice.split('<$!<>')[3];
        //     tmp['보기5'] = i.questions[0].choice.split('<$!<>')[4];

        //     tmp['정답'] = i.questions[0].answer;

        //      tmp['난이도'] = i.questions[0].difficulty; //난이도

        //     const keywordList =await questionService.getQuestionKeywords({
        //         questionId: i.questions[0].question_id,
        //     });
            
        //     tmp['키워드']=keywordList.data[0].keyword;
            
        //     keywordList.data.forEach(async (i) =>{
            
        //       tmp['키워드'] += ','
        //       tmp['키워드'] += i.keyword;              
        //     });
        //      tmp['키워드 배점']=keywordList.data[0].score_portion;
            
        //     keywordList.data.forEach(async (i) =>{
            
        //       tmp['키워드 배점'] += ','
        //       tmp['키워드 배점'] += i.score_portion;              
        //     });
        //     await Multi_Ans_list.push(tmp);
        //   }         
        //   if(i.questions[0].type === 2) //서술형인 경우
        //   {
        //     let tmp = { };
        //     switch(i.order)
        //     {
        //       case 0 : tmp['타입'] = '예습'; break;
        //       case 1 : tmp['타입'] = '본강'; break;
        //       case 2 : tmp['타입'] = '복습'; break;
        //     }
            
        //     tmp['아이템 이름'] =i.name; //아이템 이름
         
        //     switch(i.result)
        //     {
        //       case 0 : tmp['답안 공개 여부'] = '답안은 공개되지 않습니다..'; break;
        //       case 3 : tmp['답안 공개 여부'] = "답안은 강사님이 아이템을 내리실때 공개됩니다."; break;
            
        //     }
        //     tmp['문제'] = i.questions[0].question; //문제
        //     tmp['모범 답안'] = i.questions[0].answer; //문제
            
        //    tmp['난이도'] = i.questions[0].difficulty; //난이도
            
        //     if(i.limit_length != null)
        //     {
        //       tmp['글자수 제한'] = "제한 있음";
        //     }
        //     else tmp['글자수 제한'] = "제한없음"; //글자수 제한 여부
            
        //     if(i.limit_length != null)
        //     {
        //       tmp['제한 수'] = i.limit_length;
        //     }
        //     else tmp['제한 수'] = " "; //글자수 제한수

        //     const keywordList = await questionService.getQuestionKeywords({ 
        //         questionId: i.questions[0].question_id,
        //     });
            
        //     tmp['키워드']=keywordList.data[0].keyword;
            
        //     keywordList.data.forEach(async (i) => {
            
        //       tmp['키워드'] += ','
        //       tmp['키워드'] += i.keyword;              
        //     });
        //      tmp['키워드 배점']=keywordList.data[0].score_portion;
            
        //     keywordList.data.forEach(async (i) =>{
            
        //       tmp['키워드 배점'] += ','
        //       tmp['키워드 배점'] += i.score_portion;              
        //     });
        //     await Essay_list.push(tmp);
        //   }
        // }
        // });


      //   vm.lectureItemList.forEach(async (i) =>{
      //     if(i.type === '문항') //문항에 대해서만 excel 다운로드
      //     {
      //       if(i.questions[0].type === 1) //단답형인 경우
      //       {
      //         var tmp = { };
      //         switch(i.order)
      //         {
      //           case 0 : tmp['타입'] = '예습'; break;
      //           case 1 : tmp['타입'] = '본강'; break;
      //           case 2 : tmp['타입'] = '복습'; break;
      //         }
            
      //         tmp['아이템 이름'] =i.name; //아이템 이름
            
      //         switch(i.result)
      //         {
      //           case 0 : tmp['답안 공개 여부'] = '답안은 공개되지 않습니다..'; break;
      //           case 3 : tmp['답안 공개 여부'] = "답안은 강사님이 아이템을 내리실때 공개됩니다."; break;
              
      //         }
            
      //         tmp['문제'] = i.questions[0].question; //문제
      //         tmp['답'] = i.questions[0].answer; //답안
      //         tmp['난이도'] = i.questions[0].difficulty; //난이도
              
      //         if(i.limit_length != null)
      //         {
      //           tmp['글자수 제한'] = "제한 있음";
      //         }
      //         else tmp['글자수 제한'] = "제한없음"; //글자수 제한 여부
              
      //         if(i.limit_length != null)
      //         {
      //           tmp['제한 수'] = i.limit_length;
      //         }
      //         else tmp['제한 수'] = " "; //글자수 제한수

      //         console.log('echo1');
              
      //         const keywordList = await questionService.getQuestionKeywords({
      //             questionId: i.questions[0].question_id,
      //         });
              
      //         console.log('echo2');
      //         tmp['키워드']=keywordList.data[0].keyword;
              
      //         keywordList.data.forEach(async (i) =>{
              
      //           tmp['키워드'] += ','
      //           tmp['키워드'] += i.keyword;              
      //         });
      //         tmp['키워드 배점']=keywordList.data[0].score_portion;
              
      //         keywordList.data.forEach(async (i) =>{            
      //           tmp['키워드 배점'] += ','
      //           tmp['키워드 배점'] += i.score_portion;              
      //         });

      //         Short_Ans_list.push(tmp);                  
      //       }
      //       if(i.questions[0].type === 0) //객관형인 경우
      //       {
      //         let tmp = { };
      //         switch(i.order)
      //         {
      //           case 0 : tmp['타입'] = '예습'; break;
      //           case 1 : tmp['타입'] = '본강'; break;
      //           case 2 : tmp['타입'] = '복습'; break;
      //         }
              
      //         tmp['아이템 이름'] = i.name; //아이템 이름
          
      //         switch(i.result)
      //         {
      //           case 0 : tmp['답안 공개 여부'] = '답안은 공개되지 않습니다..'; break;
      //           case 3 : tmp['답안 공개 여부'] = "답안은 강사님이 아이템을 내리실때 공개됩니다."; break;
              
      //         }
      //         tmp['문제'] = i.questions[0].question; //문제
      //         tmp['보기1'] = i.questions[0].choice.split('<$!<>')[0];
      //         tmp['보기2'] = i.questions[0].choice.split('<$!<>')[1];
      //         tmp['보기3'] = i.questions[0].choice.split('<$!<>')[2];
      //         tmp['보기4'] = i.questions[0].choice.split('<$!<>')[3];
      //         tmp['보기5'] = i.questions[0].choice.split('<$!<>')[4];

      //         tmp['정답'] = i.questions[0].answer;

      //         tmp['난이도'] = i.questions[0].difficulty; //난이도


      //         const keywordList =await questionService.getQuestionKeywords({
      //             questionId: i.questions[0].question_id,
      //         });
              
      //         tmp['키워드']=keywordList.data[0].keyword;
              
      //         keywordList.data.forEach(async (i) =>{
              
      //           tmp['키워드'] += ','
      //           tmp['키워드'] += i.keyword;              
      //         });
      //         tmp['키워드 배점']=keywordList.data[0].score_portion;
              
      //         keywordList.data.forEach(async (i) =>{
              
      //           tmp['키워드 배점'] += ','
      //           tmp['키워드 배점'] += i.score_portion;              
      //         });
      //         await Multi_Ans_list.push(tmp);
      //       }         
      //       if(i.questions[0].type === 2) //서술형인 경우
      //       {
      //         let tmp = { };
      //         switch(i.order)
      //         {
      //           case 0 : tmp['타입'] = '예습'; break;
      //           case 1 : tmp['타입'] = '본강'; break;
      //           case 2 : tmp['타입'] = '복습'; break;
      //         }
              
      //         tmp['아이템 이름'] =i.name; //아이템 이름
          
      //         switch(i.result)
      //         {
      //           case 0 : tmp['답안 공개 여부'] = '답안은 공개되지 않습니다..'; break;
      //           case 3 : tmp['답안 공개 여부'] = "답안은 강사님이 아이템을 내리실때 공개됩니다."; break;
              
      //         }
      //         tmp['문제'] = i.questions[0].question; //문제
      //         tmp['모범 답안'] = i.questions[0].answer; //문제
              
      //       tmp['난이도'] = i.questions[0].difficulty; //난이도
              
      //         if(i.limit_length != null)
      //         {
      //           tmp['글자수 제한'] = "제한 있음";
      //         }
      //         else tmp['글자수 제한'] = "제한없음"; //글자수 제한 여부
              
      //         if(i.limit_length != null)
      //         {
      //           tmp['제한 수'] = i.limit_length;
      //         }
      //         else tmp['제한 수'] = " "; //글자수 제한수

      //         const keywordList = await questionService.getQuestionKeywords({ 
      //             questionId: i.questions[0].question_id,
      //         });
              
      //         tmp['키워드']=keywordList.data[0].keyword;
              
      //         keywordList.data.forEach(async (i) => {
              
      //           tmp['키워드'] += ','
      //           tmp['키워드'] += i.keyword;              
      //         });
      //         tmp['키워드 배점']=keywordList.data[0].score_portion;
              
      //         keywordList.data.forEach(async (i) =>{
              
      //           tmp['키워드 배점'] += ','
      //           tmp['키워드 배점'] += i.score_portion;              
      //         });
              
      //         await Essay_list.push(tmp);
      //       }
      //     }
      //     });


      //   // Short_Ans_list = [{
      //   //   '글자수 제한': "제한없음",
      //   // }];

      //   console.log('echo3');

      //   var wb = await XLSX.utils.book_new();
      //   var newWorksheet_short_ans = await XLSX.utils.json_to_sheet(Short_Ans_list);
      //   var newWorksheet_multi_ans = await XLSX.utils.json_to_sheet(Multi_Ans_list);
      //   var newWorksheet_essay = await XLSX.utils.json_to_sheet(Essay_list);
      //   await XLSX.utils.book_append_sheet(wb, newWorksheet_short_ans,'단답형');
      //   await XLSX.utils.book_append_sheet(wb, newWorksheet_multi_ans,'객관형');
      //   await XLSX.utils.book_append_sheet(wb, newWorksheet_essay,'서술형');
      //   var wbout = XLSX.write(wb, {bookType: 'xlsx', type: 'binary'});

      //   saveAs(new Blob([s2ab(wbout)],{type:"application/octet-stream"}),'ItemListDownload.xlsx');

            
      //   console.log('echo4');

      //   function s2ab(s){ 
      //     var buf = new ArrayBuffer(s.length); //convert s to arrayBuffer
      //     var view = new Uint8Array(buf);  //create uint8array as viewer
      //     for (var i=0; i<s.length; i++) view[i] = s.charCodeAt(i) & 0xFF;
          
      //     return buf;    
      //   } 
      // },

      async ItemExcelDownload() //estlint-disable-line 
      //await이슈로 인해 for문 사용
      {
      const vm = this;
      var Short_Ans_list = []; //단답 리스트
      var Multi_Ans_list = []; //객관 리스트
      var Essay_list = []; //서술 리스트

      for(let i =0; i < vm.lectureItemList.length;i++)
      {
        if(vm.lectureItemList[i].type === '문항') //문항에 대해서만 excel 다운로드
        {
          if(vm.lectureItemList[i].questions[0].type === 1) //단답형인 경우
          {
            let tmp = { };
            switch(vm.lectureItemList[i].order)
            {
              case 0 : tmp['타입'] = '예습'; break;
              case 1 : tmp['타입'] = '본강'; break;
              case 2 : tmp['타입'] = '복습'; break;
            }
            
            tmp['아이템 이름'] = vm.lectureItemList[i].name; //아이템 이름
         
            switch(vm.lectureItemList[i].result)
            {
              case 0 : tmp['답안 공개 여부'] = '답안은 공개되지 않습니다.'; break;
              case 3 : tmp['답안 공개 여부'] = '답안은 강사님이 아이템을 내리실때 공개됩니다.'; break;
            
            }
            tmp['문제'] = vm.lectureItemList[i].questions[0].question; //문제
            tmp['답'] = vm.lectureItemList[i].questions[0].answer; //답안
            tmp['난이도'] = vm.lectureItemList[i].questions[0].difficulty; //난이도
            
            if(vm.lectureItemList[i].limit_length != null)
            {
              tmp['글자수 제한'] = '제한 있음';
            }
            else tmp['글자수 제한'] = '제한없음'; //글자수 제한 여부
            
            if(vm.lectureItemList[i].limit_length != null)
            {
              tmp['제한 수'] = vm.lectureItemList[i].limit_length;
            }
            else tmp['제한 수'] = " "; //글자수 제한수

            const keywordList = await questionService.getQuestionKeywords({
                questionId: vm.lectureItemList[i].questions[0].question_id,
            });
            
            tmp['키워드']=keywordList.data[0].keyword;
            
            for(let i = 1; i<keywordList.data.length;i++)
            {
              tmp['키워드'] += ','
              tmp['키워드'] += keywordList.data[i].keyword;              
            }
             tmp['키워드 배점']=keywordList.data[0].score_portion;
            
            for(let i = 1; i<keywordList.data.length;i++)
            {
              tmp['키워드 배점'] += ','
              tmp['키워드 배점'] += keywordList.data[i].score_portion;              
            }
            Short_Ans_list.push(tmp);            
          }
          if(vm.lectureItemList[i].questions[0].type === 0) //객관형인 경우
          {
            let tmp = { };
            switch(vm.lectureItemList[i].order)
            {
              case 0 : tmp['타입'] = '예습'; break;
              case 1 : tmp['타입'] = '본강'; break;
              case 2 : tmp['타입'] = '복습'; break;
            }
            
            tmp['아이템 이름'] = vm.lectureItemList[i].name; //아이템 이름
         
            switch(vm.lectureItemList[i].result)
            {
              case 0 : tmp['답안 공개 여부'] = '답안은 공개되지 않습니다..'; break;
              case 3 : tmp['답안 공개 여부'] = '답안은 강사님이 아이템을 내리실때 공개됩니다.'; break;
            
            }
            tmp['문제'] = vm.lectureItemList[i].questions[0].question; //문제
            tmp['보기1'] = vm.lectureItemList[i].questions[0].choice.split('<$!<>')[0];
            tmp['보기2'] = vm.lectureItemList[i].questions[0].choice.split('<$!<>')[1];
            tmp['보기3'] = vm.lectureItemList[i].questions[0].choice.split('<$!<>')[2];
            tmp['보기4'] = vm.lectureItemList[i].questions[0].choice.split('<$!<>')[3];
            tmp['보기5'] = vm.lectureItemList[i].questions[0].choice.split('<$!<>')[4];

            tmp['정답'] = vm.lectureItemList[i].questions[0].answer;

             tmp['난이도'] = vm.lectureItemList[i].questions[0].difficulty; //난이도

            const keywordList = await questionService.getQuestionKeywords({
                questionId: vm.lectureItemList[i].questions[0].question_id,
            });
            
            tmp['키워드']=keywordList.data[0].keyword;
            
            for(let i = 1; i<keywordList.data.length;i++)
            {
              tmp['키워드'] += ','
              tmp['키워드'] += keywordList.data[i].keyword;              
            }
             tmp['키워드 배점']=keywordList.data[0].score_portion;
            
            for(let i = 1; i<keywordList.data.length;i++)
            {
              tmp['키워드 배점'] += ','
              tmp['키워드 배점'] += keywordList.data[i].score_portion;              
            }
            Multi_Ans_list.push(tmp);
          }         
          if(vm.lectureItemList[i].questions[0].type === 2) //서술형인 경우
          {
            let tmp = { };
            switch(vm.lectureItemList[i].order)
            {
              case 0 : tmp['타입'] = '예습'; break;
              case 1 : tmp['타입'] = '본강'; break;
              case 2 : tmp['타입'] = '복습'; break;
            }
            
            tmp['아이템 이름'] = vm.lectureItemList[i].name; //아이템 이름
         
            switch(vm.lectureItemList[i].result)
            {
              case 0 : tmp['답안 공개 여부'] = '답안은 공개되지 않습니다..'; break;
              case 3 : tmp['답안 공개 여부'] = '답안은 강사님이 아이템을 내리실때 공개됩니다.'; break;
            
            }
            tmp['문제'] = vm.lectureItemList[i].questions[0].question; //문제
            tmp['모범 답안'] = vm.lectureItemList[i].questions[0].answer; //문제
            
           tmp['난이도'] = vm.lectureItemList[i].questions[0].difficulty; //난이도
            
            if(vm.lectureItemList[i].limit_length != null)
            {
              tmp['글자수 제한'] = '제한 있음';
            }
            else tmp['글자수 제한'] = '제한없음'; //글자수 제한 여부
            
            if(vm.lectureItemList[i].limit_length != null)
            {
              tmp['제한 수'] = vm.lectureItemList[i].limit_length;
            }
            else tmp['제한 수'] = " "; //글자수 제한수

            const keywordList = await questionService.getQuestionKeywords({
                questionId: vm.lectureItemList[i].questions[0].question_id,
            });
            
            tmp['키워드']=keywordList.data[0].keyword;
            
            for(let i = 1; i<keywordList.data.length;i++)
            {
              tmp['키워드'] += ','
              tmp['키워드'] += keywordList.data[i].keyword;              
            }
             tmp['키워드 배점']=keywordList.data[0].score_portion;
            
            for(let i = 1; i<keywordList.data.length;i++)
            {
              tmp['키워드 배점'] += ','
              tmp['키워드 배점'] += keywordList.data[i].score_portion;              
            }
            Essay_list.push(tmp);
          }
        }
      }                  
          var wb = XLSX.utils.book_new();
          var newWorksheet_short_ans = XLSX.utils.json_to_sheet(Short_Ans_list);
          var newWorksheet_multi_ans = XLSX.utils.json_to_sheet(Multi_Ans_list);
          var newWorksheet_essay = XLSX.utils.json_to_sheet(Essay_list);
          XLSX.utils.book_append_sheet(wb, newWorksheet_short_ans,'단답형');
          XLSX.utils.book_append_sheet(wb, newWorksheet_multi_ans,'객관형');
          XLSX.utils.book_append_sheet(wb, newWorksheet_essay,'서술형');
          var wbout = XLSX.write(wb, {bookType: 'xlsx', type: 'binary'});
          saveAs(new Blob([s2ab(wbout)],{type:"application/octet-stream"}),'ItemListDownload.xlsx');
          function s2ab(s) 
          { 
            var buf = new ArrayBuffer(s.length); //convert s to arrayBuffer
            var view = new Uint8Array(buf);  //create uint8array as viewer
            for (var i=0; i<s.length; i++) view[i] = s.charCodeAt(i) & 0xFF; //convert to octet
            return buf;    
          } 
          
        }
    },   
  

    async mounted() {
      const vm = this;
      await vm.getLecture({
        lectureId: vm.lectureId
      });
      /*const element = document.getElementById('LectureItemList');
      element.addEventListener('dragend', () => {
        vm.onClick('ADD_LC_ITEM_SEQUENCE');
      });*/
      vm.lectureType = vm.lecture.type;
      vm.addTableEventListener();
    },
    
  };
</script>